#include <sourcemod>
#define Version "1.2.1"
#define BaseMode 2

new Handle:Allowed = INVALID_HANDLE;
new Handle:cvarAnnounce = INVALID_HANDLE;
new Handle:DefaultMode = INVALID_HANDLE;
new Handle:CurrentGameMode;
new DisplayMode[MAXPLAYERS+1] = {BaseMode, ...};
new Damage[MAXPLAYERS+1][MAXPLAYERS+1];
new CurrentDamage[MAXPLAYERS+1][MAXPLAYERS+1];
new TotalDamageDone[MAXPLAYERS+1];
new TotalDamageReceived[MAXPLAYERS+1];
new TotalDamageDoneTA[MAXPLAYERS+1];
new TotalDamageReceivedTA[MAXPLAYERS+1];
new TotalDamageReceivedInfected[MAXPLAYERS+1];
new InfectedKills[MAXPLAYERS+1];
new PlayerKills[MAXPLAYERS+1];
// Fix incorrect calculation CurrentDamage at round change
new FirstHurt[MAXPLAYERS+1][MAXPLAYERS+1];

public Plugin:myinfo = 
{
	name = "Damage Info Display",
	author = "Dionys",
	description = "Display the damage info.",
	version = Version,
	url = "skiner@inbox.ru"
};

public OnPluginStart()
{
	decl String:ModName[50];
	GetGameFolderName(ModName, sizeof(ModName));

	if(!StrEqual(ModName, "left4dead", false))
	{
		SetFailState("Use this Left 4 Dead only.");
	}

	LoadTranslations("plugin.sm_did");
	AutoExecConfig(true, "sm_did");

	//Events we need to hook
	HookEvent("player_hurt", Event_PlayerHurt);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("infected_death", Event_InfectedDeath);
	HookEvent("round_end", Event_RoundEnd);
	HookEvent("door_close", Event_DoorClose);

	CreateConVar("sm_did_version", Version, "Version of Display Damage plugin.", FCVAR_NOTIFY);
	Allowed = CreateConVar("sm_did_enabled","1","Enables Display Damage to players.");
	CurrentGameMode = CreateConVar("sm_did_gmode", "0", "Selected GameMode: 0 -coop/1 - versus.");
	DefaultMode = CreateConVar("sm_did_default","2","Default Display Damage mode. 1 = all; 2 = damage done; 3 = damage received; any other = no display.");
	cvarAnnounce = CreateConVar("sm_did_announce","1","Enables Display Damage to advertise to players.");
	RegConsoleCmd("sm_did_mode", DIDMenu);
	RegConsoleCmd("sm_did", cmdCallDID, "Call DID Total Panel");
	RegConsoleCmd("sm_did_zero", cmdClearDID, "Clear all Damages");
}

public OnClientPutInServer(client)
{
	if(client)
	{
		for (new Arg1=1; Arg1<=GetMaxClients(); Arg1++)
		{
			FirstHurt[Arg1][client] = 1;
			FirstHurt[client][Arg1] = 1;
		}

		TotalDamageDone[client] = 0;
		TotalDamageReceived[client] = 0;
		TotalDamageDoneTA[client] = 0;
		TotalDamageReceivedTA[client] = 0;
		TotalDamageReceivedInfected[client] = 0;
		InfectedKills[client] = 0;
		PlayerKills[client] = 0;

		if(!IsFakeClient(client))
		{
			// Give users default setting
			DisplayMode[client] = GetConVarInt(DefaultMode);
			// Make the announcement in 30 seconds unless announcements are turned off
			if(GetConVarBool(cvarAnnounce))
				CreateTimer(30.0, TimerAnnounce, client);
		}
	}
}

public Handler_DeathPanel(Handle:menu, MenuAction:action, param1, param2)
{
}

// Mode switcher
public DIDMenuHandler(Handle:menu, MenuAction:action, param1, param2)
{
	new ModeCheck = DisplayMode[param1];
	param2 = param2 + 1;

	if (action == MenuAction_Select)
	{
		if(param2 == 4)
		{
			DisplayMode[param1] = 0;
		}
		else
		{
			DisplayMode[param1] = param2;
		}

		if (ModeCheck == DisplayMode[param1])
		{
			PrintToChat(param1, "\x04[SM]\x03 %t", "menu stay mode");
		}
		else
		{
			if (DisplayMode[param1] == 1)
				PrintToChat(param1, "\x04[SM]\x03 %t \x04%t\x03", "menu get mode", "menu all mode");
			if (DisplayMode[param1] == 2)
				PrintToChat(param1, "\x04[SM]\x03 %t \x04%t\x03", "menu get mode", "menu done mode");
			if (DisplayMode[param1] == 3)
				PrintToChat(param1, "\x04[SM]\x03 %t \x04%t\x03", "menu get mode", "menu received mode");
			if (DisplayMode[param1] == 0)
				PrintToChat(param1, "\x04[SM]\x03 %t \x04%t\x03", "menu get mode", "menu disable mode");
		}
	}
	else if(action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

//  This creates menu
public Action:DIDMenu(client, args)
{
	new Handle:menu = CreateMenu(DIDMenuHandler);
	decl String:mBuffer[100];
	
	Format(mBuffer, sizeof(mBuffer), "%t", "DID Menu", client);
	SetMenuTitle(menu, mBuffer);

	if(DisplayMode[client] == 1)
		Format(mBuffer, sizeof(mBuffer), "%t [%t]", "menu all mode", "menu current use", client);
	else
		Format(mBuffer, sizeof(mBuffer), "%t", "menu all mode", client);
	AddMenuItem(menu, "mode all", mBuffer);
	if(DisplayMode[client] == 2)
		Format(mBuffer, sizeof(mBuffer), "%t [%t]", "menu done mode", "menu current use", client);
	else
		Format(mBuffer, sizeof(mBuffer), "%t", "menu done mode", client);
	AddMenuItem(menu, "mode dd", mBuffer);
	if(DisplayMode[client] == 3)
		Format(mBuffer, sizeof(mBuffer), "%t [%t]", "menu received mode", "menu current use", client);
	else
		Format(mBuffer, sizeof(mBuffer), "%t", "menu received mode", client);
	AddMenuItem(menu, "mode dt", mBuffer);
	if(DisplayMode[client] == 0)
		Format(mBuffer, sizeof(mBuffer), "%t [%t]", "menu disable mode", "menu current use", client);
	else
		Format(mBuffer, sizeof(mBuffer), "%t", "menu disable mode", client);
	AddMenuItem(menu, "mode off", mBuffer);
 
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
 
	return Plugin_Handled;
}

public Action:Event_PlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(Allowed))
	{
		new DamageHealth = GetEventInt(event, "dmg_health");

		//Total game event byte length must be < 1024
		if(DamageHealth < 1024)
		{
			new victim = GetClientOfUserId(GetEventInt(event, "userid"));
			new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));

			if (FirstHurt[attacker][victim] == 1)
			{
				Damage[attacker][victim] = 0;
				CurrentDamage[attacker][victim] = 0;
				FirstHurt[attacker][victim] = 0;
			}

			Damage[attacker][victim] += DamageHealth;
			CurrentDamage[attacker][victim] += DamageHealth;

			// Display info
			if(victim && attacker && victim != 0 && attacker != 0)
			{
				if(GetClientTeam(victim) == GetClientTeam(attacker))
				{
					TotalDamageReceivedTA[victim] += Damage[attacker][victim];
					TotalDamageDoneTA[attacker] += Damage[attacker][victim];

					if(DisplayMode[victim] == 1 || DisplayMode[victim] == 3)
						PrintHintText(victim, "-TA!!! %N %t %iHP.", attacker, "Hint EtoP Hurt", CurrentDamage[attacker][victim]);
					if(DisplayMode[attacker] == 1 || DisplayMode[attacker] == 2)
						PrintHintText(attacker, "+TA!!! %t %N: %iHP.", "Hint PtoE Hurt", victim, CurrentDamage[attacker][victim]);
				}
				else
				{
					TotalDamageReceived[victim] += Damage[attacker][victim];
					TotalDamageDone[attacker] += Damage[attacker][victim];

					if(DisplayMode[victim] == 1 || DisplayMode[victim] == 3)
						PrintHintText(victim, "%N %t %iHP.", attacker, "Hint EtoP Hurt", CurrentDamage[attacker][victim]);
					if(DisplayMode[attacker] == 1 || DisplayMode[attacker] == 2)
						PrintHintText(attacker, "%t %N: %iHP.", "Hint PtoE Hurt", victim, CurrentDamage[attacker][victim]);
				}
			}
			else
				TotalDamageReceivedInfected[victim] += Damage[attacker][victim];

			Damage[attacker][victim] = 0;
		}
	}
}

public Action:Event_InfectedDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(Allowed))
	{
		new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));

		if (attacker && attacker != 0)
		{
			if(!IsFakeClient(attacker))
				InfectedKills[attacker] += 1;
		}
	}
}

public Action:Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(Allowed))
	{
		new victim = GetClientOfUserId(GetEventInt(event, "userid"));
		new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
		CurrentDamage[attacker][victim] = 0;

		if (victim && attacker && victim != 0 && attacker != 0)
		{
			if(attacker != victim && !IsFakeClient(attacker))
				PlayerKills[attacker] += 1;

			if(!IsFakeClient(victim))
			{
				decl String:pDeath[100];
				new Handle:pDeathPanel = CreatePanel(GetMenuStyleHandle(MenuStyle_Radio));
				Format(pDeath, sizeof(pDeath), "%t", "DID Total Panel", victim);
				SetPanelTitle(pDeathPanel, pDeath);
				DrawPanelItem(pDeathPanel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg done", TotalDamageDone[victim], victim);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg doneta", TotalDamageDoneTA[victim], victim);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg receive", TotalDamageReceived[victim], victim);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg zombie", TotalDamageReceivedInfected[victim], victim);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg receiveta", TotalDamageReceivedTA[victim], victim);
				DrawPanelText(pDeathPanel, pDeath);
				DrawPanelItem(pDeathPanel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
				Format(pDeath, sizeof(pDeath), "%t: %i", "pnl kill zombie", InfectedKills[victim], victim);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %i", "pnl kill player", PlayerKills[victim], victim);
				DrawPanelText(pDeathPanel, pDeath);
				SendPanelToClient(pDeathPanel, victim, Handler_DeathPanel, 10);
				CloseHandle(pDeathPanel);
			}
		}
	}
}

public Action:Event_RoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(Allowed) && GetConVarInt(CurrentGameMode) == 1)
	{
		for (new player=1; player<=GetMaxClients(); player++)
		{
			if (IsClientInGame(player) && IsPlayerAlive(player) && !IsFakeClient(player))
			{
				decl String:pDeath[100];
				new Handle:pDeathPanel = CreatePanel(GetMenuStyleHandle(MenuStyle_Radio));
				Format(pDeath, sizeof(pDeath), "%t", "DID Total Panel", player);
				SetPanelTitle(pDeathPanel, pDeath);
				DrawPanelItem(pDeathPanel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg done", TotalDamageDone[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg doneta", TotalDamageDoneTA[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg receive", TotalDamageReceived[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg zombie", TotalDamageReceivedInfected[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg receiveta", TotalDamageReceivedTA[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				DrawPanelItem(pDeathPanel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
				Format(pDeath, sizeof(pDeath), "%t: %i", "pnl kill zombie", InfectedKills[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %i", "pnl kill player", PlayerKills[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				SendPanelToClient(pDeathPanel, player, Handler_DeathPanel, 15);
				CloseHandle(pDeathPanel);
			}

			TotalDamageDone[player] = 0;
			TotalDamageReceived[player] = 0;
			TotalDamageDoneTA[player] = 0;
			TotalDamageReceivedTA[player] = 0;
			TotalDamageReceivedInfected[player] = 0;
			InfectedKills[player] = 0;
			PlayerKills[player] = 0;
		}
	}
}

public Action:Event_DoorClose(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(Allowed) && GetConVarInt(CurrentGameMode) == 0)
	{
		for (new player=1; player<=GetMaxClients(); player++)
		{
			if (IsClientInGame(player) && IsPlayerAlive(player) && !IsFakeClient(player))
			{
				decl String:pDeath[100];
				new Handle:pDeathPanel = CreatePanel(GetMenuStyleHandle(MenuStyle_Radio));
				Format(pDeath, sizeof(pDeath), "%t", "DID Total Panel", player);
				SetPanelTitle(pDeathPanel, pDeath);
				DrawPanelItem(pDeathPanel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg done", TotalDamageDone[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg doneta", TotalDamageDoneTA[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg receive", TotalDamageReceived[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg zombie", TotalDamageReceivedInfected[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg receiveta", TotalDamageReceivedTA[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				DrawPanelItem(pDeathPanel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
				Format(pDeath, sizeof(pDeath), "%t: %i", "pnl kill zombie", InfectedKills[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				Format(pDeath, sizeof(pDeath), "%t: %i", "pnl kill player", PlayerKills[player], player);
				DrawPanelText(pDeathPanel, pDeath);
				SendPanelToClient(pDeathPanel, player, Handler_DeathPanel, 15);
				CloseHandle(pDeathPanel);
			}

			TotalDamageDone[player] = 0;
			TotalDamageReceived[player] = 0;
			TotalDamageDoneTA[player] = 0;
			TotalDamageReceivedTA[player] = 0;
			TotalDamageReceivedInfected[player] = 0;
			InfectedKills[player] = 0;
			PlayerKills[player] = 0;
		}
	}
}

public Action:cmdCallDID(client, args)
{
	decl String:pDeath[100];
	new Handle:pDeathPanel = CreatePanel(GetMenuStyleHandle(MenuStyle_Radio));
	Format(pDeath, sizeof(pDeath), "%t", "DID Total Panel", client);
	SetPanelTitle(pDeathPanel, pDeath);
	DrawPanelItem(pDeathPanel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
	Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg done", TotalDamageDone[client], client);
	DrawPanelText(pDeathPanel, pDeath);
	Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg doneta", TotalDamageDoneTA[client], client);
	DrawPanelText(pDeathPanel, pDeath);
	Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg receive", TotalDamageReceived[client], client);
	DrawPanelText(pDeathPanel, pDeath);
	Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg zombie", TotalDamageReceivedInfected[client], client);
	DrawPanelText(pDeathPanel, pDeath);
	Format(pDeath, sizeof(pDeath), "%t: %iHP", "pnl dmg receiveta", TotalDamageReceivedTA[client], client);
	DrawPanelText(pDeathPanel, pDeath);
	DrawPanelItem(pDeathPanel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
	Format(pDeath, sizeof(pDeath), "%t: %i", "pnl kill zombie", InfectedKills[client], client);
	DrawPanelText(pDeathPanel, pDeath);
	Format(pDeath, sizeof(pDeath), "%t: %i", "pnl kill player", PlayerKills[client], client);
	DrawPanelText(pDeathPanel, pDeath);
	SendPanelToClient(pDeathPanel, client, Handler_DeathPanel, 10);
	CloseHandle(pDeathPanel);
}

public Action:cmdClearDID(client, args)
{
	TotalDamageDone[client] = 0;
	TotalDamageReceived[client] = 0;
	TotalDamageDoneTA[client] = 0;
	TotalDamageReceivedTA[client] = 0;
	TotalDamageReceivedInfected[client] = 0;
	InfectedKills[client] = 0;
	PlayerKills[client] = 0;
	
	PrintToChat(client, "\x04[SM]\x03 DID now is clear.");
}

public Action:TimerAnnounce(Handle:timer, any:client)
{
	if(IsClientInGame(client))
		PrintToChat(client, "\x04[SM]\x03 %t.\n\x04!did_mode\x03 %t.\n\x04!did\x03 %t.", "Wellcome1", "Wellcome2", "Wellcome3");
}
